Index: src/Fl_Scroll.cxx
===================================================================
--- src/Fl_Scroll.cxx	(revision 6732)
+++ src/Fl_Scroll.cxx	(working copy)
@@ -29,6 +29,9 @@
 #include <FL/Fl_Tiled_Image.H>
 #include <FL/Fl_Scroll.H>
 #include <FL/fl_draw.H>
+#ifdef FL_HAVE_MSAA
+#include <FL/Fl_Msaa_Proxy.H>
+#endif
 
 /** Clear all but the scrollbars... */
 void Fl_Scroll::clear() {
@@ -317,6 +320,12 @@
   hscrollbar.type(FL_HORIZONTAL);
   hscrollbar.callback(hscrollbar_cb);
   scrollbar.callback(scrollbar_cb);
+#ifdef FL_HAVE_MSAA
+  // Initialize MSAA stuff
+  msaa_scroll_proxy_ = 0;
+  scrollbar.msaa_proxy()->OverrideParent(msaa_proxy());
+  hscrollbar.msaa_proxy()->OverrideParent(msaa_proxy());
+#endif // FL_HAVE_MSAA
 }
 
 int Fl_Scroll::handle(int event) {
@@ -324,6 +333,606 @@
   return Fl_Group::handle(event);
 }
 
+
+#ifdef FL_HAVE_MSAA
+///////////////////////////////////////////////////////////////////////
+//
+//  The following code implements Microsoft Active Accessibility
+
+#define CID_INSIDE	1
+#define CID_VERTICAL	2
+#define CID_HORIZONTAL	3
+#define CID_GRIP	4
+
+
+class Fl_Msaa_Scroll_Proxy : public Fl_Msaa_Proxy
+{
+public:
+  Fl_Msaa_Scroll_Proxy(Fl_Widget* o) : Fl_Msaa_Proxy(o)  {}
+  long LookupChild(Fl_Widget* o);
+
+  // IAccessible implementation
+  HRESULT STDMETHODCALLTYPE get_accParent(IDispatch**);
+  HRESULT STDMETHODCALLTYPE get_accChildCount(long*);
+  HRESULT STDMETHODCALLTYPE get_accChild(VARIANT, IDispatch**);
+  HRESULT STDMETHODCALLTYPE get_accName(VARIANT, BSTR*);
+  HRESULT STDMETHODCALLTYPE get_accValue(VARIANT, BSTR*);
+  HRESULT STDMETHODCALLTYPE get_accDescription(VARIANT, BSTR*);
+  HRESULT STDMETHODCALLTYPE get_accRole(VARIANT, VARIANT*);
+  HRESULT STDMETHODCALLTYPE get_accState(VARIANT, VARIANT*);
+  HRESULT STDMETHODCALLTYPE get_accHelp(VARIANT, BSTR*);
+  HRESULT STDMETHODCALLTYPE get_accHelpTopic(BSTR*, VARIANT, long*);
+  HRESULT STDMETHODCALLTYPE get_accKeyboardShortcut(VARIANT, BSTR*);
+  HRESULT STDMETHODCALLTYPE get_accFocus(VARIANT*);
+  HRESULT STDMETHODCALLTYPE get_accSelection(VARIANT*);
+  HRESULT STDMETHODCALLTYPE get_accDefaultAction(VARIANT, BSTR*);
+  HRESULT STDMETHODCALLTYPE accSelect(long, VARIANT);
+  HRESULT STDMETHODCALLTYPE accLocation(long*, long*, long*, long*, VARIANT);
+  HRESULT STDMETHODCALLTYPE accNavigate(long, VARIANT, VARIANT*);
+  HRESULT STDMETHODCALLTYPE accHitTest(long, long, VARIANT*);
+  HRESULT STDMETHODCALLTYPE accDoDefaultAction(VARIANT);
+  HRESULT STDMETHODCALLTYPE put_accValue(VARIANT, BSTR);
+};
+
+
+long
+Fl_Msaa_Scroll_Proxy::LookupChild(Fl_Widget* o)
+{
+  Fl_Scroll* scroll = (Fl_Scroll*)mpObj;
+  if (!scroll)  return -1;
+  if (o == &scroll->scrollbar)  return CID_VERTICAL;
+  if (o == &scroll->hscrollbar)  return CID_HORIZONTAL;
+  return -1;
+}
+
+
+HRESULT STDMETHODCALLTYPE
+Fl_Msaa_Scroll_Proxy::get_accParent(
+    /* [retval][out] */ IDispatch** ppdispParent)
+{
+  Fl_Scroll* scroll = (Fl_Scroll*)mpObj;
+  if (!scroll)  return CO_E_OBJNOTCONNECTED;
+  if (!ppdispParent)  return E_INVALIDARG;
+  *ppdispParent = NULL;
+
+  // Fl_Msaa_Scroll_Proxy_ is directly under parent widget
+  if (!scroll->msaa_scroll_parent(ppdispParent))  return S_FALSE;
+  return S_OK;
+}
+
+
+HRESULT STDMETHODCALLTYPE
+Fl_Msaa_Scroll_Proxy::get_accChildCount(
+    /* [retval][out] */ long* pcountChildren)
+{
+  Fl_Scroll* scroll = (Fl_Scroll*)mpObj;
+  if (!scroll)  return CO_E_OBJNOTCONNECTED;
+  if (!pcountChildren)  return E_INVALIDARG;
+
+  *pcountChildren = scroll->msaa_scroll_size();
+  return S_OK;
+}
+
+
+HRESULT STDMETHODCALLTYPE
+Fl_Msaa_Scroll_Proxy::get_accChild(
+    /* [in] */ VARIANT varChild,
+    /* [retval][out] */ IDispatch** ppdispChild)
+{
+  Fl_Scroll* scroll = (Fl_Scroll*)mpObj;
+  if (!scroll)  return CO_E_OBJNOTCONNECTED;
+  if (varChild.vt != VT_I4)  return E_INVALIDARG;
+  if (!ppdispChild)  return E_INVALIDARG;
+  *ppdispChild = NULL;
+  long id = (varChild.vt == VT_I4 ? varChild.lVal : 0);
+  if (id < 0 || id > scroll->msaa_scroll_size())  return E_INVALIDARG;
+
+  Fl_Msaa_Proxy* proxy = scroll->msaa_scroll_child(id);
+  if (!proxy)  return S_FALSE;
+  proxy->QueryInterface(IID_IDispatch, (void**)ppdispChild);
+  return S_OK;
+}
+
+
+HRESULT STDMETHODCALLTYPE
+Fl_Msaa_Scroll_Proxy::get_accName(
+    /* [optional][in] */ VARIANT varChild,
+    /* [retval][out] */ BSTR* pszName)
+{
+  Fl_Scroll* scroll = (Fl_Scroll*)mpObj;
+  if (!scroll)  return CO_E_OBJNOTCONNECTED;
+  if (!pszName)  return E_INVALIDARG;
+  *pszName = NULL;
+  long id = (varChild.vt == VT_I4 ? varChild.lVal : 0);
+  if (id < 0 || id > scroll->msaa_scroll_size())  return E_INVALIDARG;
+
+  return DISP_E_MEMBERNOTFOUND;
+}
+
+
+HRESULT STDMETHODCALLTYPE
+Fl_Msaa_Scroll_Proxy::get_accValue(
+    /* [optional][in] */ VARIANT varChild,
+    /* [retval][out] */ BSTR* pszValue)
+{
+  Fl_Scroll* scroll = (Fl_Scroll*)mpObj;
+  if (!scroll)  return CO_E_OBJNOTCONNECTED;
+  if (!pszValue)  return E_INVALIDARG;
+  *pszValue = NULL;
+  long id = (varChild.vt == VT_I4 ? varChild.lVal : 0);
+  if (id < 0 || id > scroll->msaa_scroll_size())  return E_INVALIDARG;
+
+  return DISP_E_MEMBERNOTFOUND;
+}
+
+
+HRESULT STDMETHODCALLTYPE
+Fl_Msaa_Scroll_Proxy::get_accDescription(
+    /* [optional][in] */ VARIANT varChild,
+    /* [retval][out] */ BSTR* pszDescription)
+{
+  Fl_Scroll* scroll = (Fl_Scroll*)mpObj;
+  if (!scroll)  return CO_E_OBJNOTCONNECTED;
+  if (!pszDescription)  return E_INVALIDARG;
+  *pszDescription = NULL;
+  long id = (varChild.vt == VT_I4 ? varChild.lVal : 0);
+  if (id < 0 || id > scroll->msaa_scroll_size())  return E_INVALIDARG;
+
+  return DISP_E_MEMBERNOTFOUND;
+}
+
+
+HRESULT STDMETHODCALLTYPE
+Fl_Msaa_Scroll_Proxy::get_accRole(
+    /* [optional][in] */ VARIANT varChild,
+    /* [retval][out] */ VARIANT* pvarRole)
+{
+  Fl_Scroll* scroll = (Fl_Scroll*)mpObj;
+  if (!scroll)  return CO_E_OBJNOTCONNECTED;
+  if (!pvarRole)  return E_INVALIDARG;
+  pvarRole->vt = VT_EMPTY;
+  long id = (varChild.vt == VT_I4 ? varChild.lVal : 0);
+  if (id < 0 || id > scroll->msaa_scroll_size())  return E_INVALIDARG;
+
+  pvarRole->vt   = VT_I4;
+  pvarRole->lVal = scroll->msaa_scroll_role(id);
+  return S_OK;
+}
+
+
+HRESULT STDMETHODCALLTYPE
+Fl_Msaa_Scroll_Proxy::get_accState(
+    /* [optional][in] */ VARIANT varChild,
+    /* [retval][out] */ VARIANT* pvarState)
+{
+  Fl_Scroll* scroll = (Fl_Scroll*)mpObj;
+  if (!scroll)  return CO_E_OBJNOTCONNECTED;
+  if (!pvarState)  return E_INVALIDARG;
+  pvarState->vt = VT_EMPTY;
+  long id = (varChild.vt == VT_I4 ? varChild.lVal : 0);
+  if (id < 0 || id > scroll->msaa_scroll_size())  return E_INVALIDARG;
+
+  pvarState->vt   = VT_I4;
+  pvarState->lVal = scroll->msaa_scroll_state(id);
+  return S_OK;
+}
+
+
+HRESULT STDMETHODCALLTYPE
+Fl_Msaa_Scroll_Proxy::get_accHelp(
+    /* [optional][in] */ VARIANT varChild,
+    /* [retval][out] */ BSTR* pszHelp)
+{
+  Fl_Scroll* scroll = (Fl_Scroll*)mpObj;
+  if (!scroll)  return CO_E_OBJNOTCONNECTED;
+  if (!pszHelp)  return E_INVALIDARG;
+  *pszHelp = NULL;
+  long id = (varChild.vt == VT_I4 ? varChild.lVal : 0);
+  if (id < 0 || id > scroll->msaa_scroll_size())  return E_INVALIDARG;
+
+  return DISP_E_MEMBERNOTFOUND;
+}
+
+
+HRESULT STDMETHODCALLTYPE
+Fl_Msaa_Scroll_Proxy::get_accHelpTopic(
+    /* [out] */ BSTR* pszHelpFile,
+    /* [optional][in] */ VARIANT varChild,
+    /* [retval][out] */ long* pidTopic)
+{
+  Fl_Scroll* scroll = (Fl_Scroll*)mpObj;
+  if (!scroll)  return CO_E_OBJNOTCONNECTED;
+  if (!pszHelpFile)  return E_INVALIDARG;
+  if (!pidTopic)  return E_INVALIDARG;
+  *pszHelpFile = NULL;
+  *pidTopic = 0;
+  long id = (varChild.vt == VT_I4 ? varChild.lVal : 0);
+  if (id < 0 || id > scroll->msaa_scroll_size())  return E_INVALIDARG;
+
+  return DISP_E_MEMBERNOTFOUND;
+}
+
+
+HRESULT STDMETHODCALLTYPE
+Fl_Msaa_Scroll_Proxy::get_accKeyboardShortcut(
+    /* [optional][in] */ VARIANT varChild,
+    /* [retval][out] */ BSTR* pszKeyboardShortcut)
+{
+  Fl_Scroll* scroll = (Fl_Scroll*)mpObj;
+  if (!scroll)  return CO_E_OBJNOTCONNECTED;
+  if (!pszKeyboardShortcut)  return E_INVALIDARG;
+  *pszKeyboardShortcut = NULL;
+  long id = (varChild.vt == VT_I4 ? varChild.lVal : 0);
+  if (id < 0 || id > scroll->msaa_scroll_size())  return E_INVALIDARG;
+
+  return DISP_E_MEMBERNOTFOUND;
+}
+
+
+HRESULT STDMETHODCALLTYPE
+Fl_Msaa_Scroll_Proxy::get_accFocus(
+    /* [retval][out] */ VARIANT *pvarChild)
+{
+  Fl_Scroll* scroll = (Fl_Scroll*)mpObj;
+  if (!scroll)  return CO_E_OBJNOTCONNECTED;
+  if (!pvarChild)  return E_INVALIDARG;
+  pvarChild->vt = VT_EMPTY;
+
+  if (scroll->msaa_focus() < 0)  return S_OK;
+  Fl_Msaa_Proxy* proxy = scroll->msaa_child(0);
+  if (!proxy)
+  {
+    pvarChild->vt   = VT_I4;
+    pvarChild->lVal = CID_INSIDE;
+  }
+  else
+  {
+    pvarChild->vt = VT_DISPATCH;
+    proxy->QueryInterface(IID_IDispatch, (void**)&pvarChild->pdispVal);
+  }
+  return S_OK;
+}
+
+
+HRESULT STDMETHODCALLTYPE
+Fl_Msaa_Scroll_Proxy::get_accSelection(
+    /* [retval][out] */ VARIANT* pvarChildren)
+{
+  Fl_Scroll* scroll = (Fl_Scroll*)mpObj;
+  if (!scroll)  return CO_E_OBJNOTCONNECTED;
+  if (!pvarChildren)  return E_INVALIDARG;
+  pvarChildren->vt = VT_EMPTY;
+
+  return S_OK;
+}
+
+
+HRESULT STDMETHODCALLTYPE
+Fl_Msaa_Scroll_Proxy::get_accDefaultAction(
+    /* [optional][in] */ VARIANT varChild,
+    /* [retval][out] */ BSTR* pszDefaultAction)
+{
+  Fl_Scroll* scroll = (Fl_Scroll*)mpObj;
+  if (!scroll)  return CO_E_OBJNOTCONNECTED;
+  if (!pszDefaultAction)  return E_INVALIDARG;
+  pszDefaultAction = NULL;
+  long id = (varChild.vt == VT_I4 ? varChild.lVal : 0);
+  if (id < 0 || id > scroll->msaa_scroll_size())  return E_INVALIDARG;
+
+  return DISP_E_MEMBERNOTFOUND;
+}
+
+
+HRESULT STDMETHODCALLTYPE
+Fl_Msaa_Scroll_Proxy::accSelect(
+    /* [in] */ long flagsSelect,
+    /* [optional][in] */ VARIANT varChild)
+{
+  Fl_Scroll* scroll = (Fl_Scroll*)mpObj;
+  if (!scroll)  return CO_E_OBJNOTCONNECTED;
+  long id = (varChild.vt == VT_I4 ? varChild.lVal : 0);
+  if (id < 0 || id > scroll->msaa_scroll_size())  return E_INVALIDARG;
+
+  return DISP_E_MEMBERNOTFOUND;
+}
+
+
+HRESULT STDMETHODCALLTYPE
+Fl_Msaa_Scroll_Proxy::accLocation(
+    /* [out] */ long* pxLeft,
+    /* [out] */ long* pyTop,
+    /* [out] */ long* pcxWidth,
+    /* [out] */ long* pcyHeight,
+    /* [optional][in] */ VARIANT varChild)
+{
+  Fl_Scroll* scroll = (Fl_Scroll*)mpObj;
+  if (!scroll)  return CO_E_OBJNOTCONNECTED;
+  if (!pxLeft || !pyTop || !pcxWidth || !pcyHeight)  return E_INVALIDARG;
+  *pxLeft = *pyTop = *pcxWidth = *pcyHeight = 0;
+  long id = (varChild.vt == VT_I4 ? varChild.lVal : 0);
+  if (id < 0 || id > scroll->msaa_scroll_size())  return E_INVALIDARG;
+
+  if (!scroll->msaa_scroll_location(id, pxLeft, pyTop, pcxWidth, pcyHeight))
+    return DISP_E_MEMBERNOTFOUND;
+  return S_OK;
+}
+
+
+HRESULT STDMETHODCALLTYPE
+Fl_Msaa_Scroll_Proxy::accNavigate(
+    /* [in] */ long navDir,
+    /* [optional][in] */ VARIANT varStart,
+    /* [retval][out] */ VARIANT* pvarEndUpAt)
+{
+  Fl_Scroll* scroll = (Fl_Scroll*)mpObj;
+  if (!scroll)  return CO_E_OBJNOTCONNECTED;
+  if (!pvarEndUpAt)  return E_INVALIDARG;
+  pvarEndUpAt->vt = VT_EMPTY;
+  long id = (varStart.vt == VT_I4 ? varStart.lVal : 0);
+  if (id < 0 || id > scroll->msaa_scroll_size())  return E_INVALIDARG;
+
+  // Handle navigation relative to this widget
+  if ((id == 0) &&
+      (navDir != NAVDIR_FIRSTCHILD) && (navDir != NAVDIR_LASTCHILD))
+    return Fl_Msaa_Proxy::accNavigate(navDir, varStart, pvarEndUpAt);
+
+  // Handle navigation within scroll content
+  long max_id = scroll->msaa_scroll_size();
+  if (max_id < 1)  return DISP_E_MEMBERNOTFOUND;
+  long dst;
+  switch (navDir)
+  {
+    case NAVDIR_FIRSTCHILD:  dst = 1;  break;
+    case NAVDIR_LASTCHILD:   dst = max_id;  break;
+    case NAVDIR_PREVIOUS:    dst = (id == 1 ? -1 : (id - 1));  break;
+    case NAVDIR_NEXT:	     dst = (id == max_id ? -1 : (id + 1));  break;
+
+    // Spatial navigation not implemented
+    case NAVDIR_UP:	     // Fall through
+    case NAVDIR_DOWN:	     // Fall through
+    case NAVDIR_LEFT:	     // Fall through
+    case NAVDIR_RIGHT:	     // Fall through
+    default:		     dst = -1;  break;
+  }
+  if (dst < 0)  return DISP_E_MEMBERNOTFOUND;
+  Fl_Msaa_Proxy* proxy = scroll->msaa_scroll_child(dst);
+  if (!proxy)
+  {
+    pvarEndUpAt->vt   = VT_I4;
+    pvarEndUpAt->lVal = dst;
+  }
+  else
+  {
+    pvarEndUpAt->vt = VT_DISPATCH;
+    proxy->QueryInterface(IID_IDispatch, (void**)&pvarEndUpAt->pdispVal);
+  }
+  return S_OK;
+}
+
+
+HRESULT STDMETHODCALLTYPE
+Fl_Msaa_Scroll_Proxy::accHitTest(
+    /* [in] */ long xLeft,
+    /* [in] */ long yTop,
+    /* [retval][out] */ VARIANT* pvarChild)
+{
+  Fl_Scroll* scroll = (Fl_Scroll*)mpObj;
+  if (!scroll)  return CO_E_OBJNOTCONNECTED;
+  if (!pvarChild)  return E_INVALIDARG;
+  pvarChild->vt = VT_EMPTY;
+
+  // Make sure the point is inside this widget
+  long X, Y, W, H;
+  if (!scroll->msaa_scroll_location(0, &X, &Y, &W, &H))  return S_FALSE;
+  if ((xLeft < X) || (xLeft >= (X + W)))  return S_FALSE;
+  if ((yTop < Y) || (yTop >= (Y + H)))  return S_FALSE;
+
+  // Check child elements from top to bottom
+  for (int n = scroll->msaa_scroll_size();  n > 0;  --n)
+  {
+    if (!scroll->msaa_scroll_location(n, &X, &Y, &W, &H))  continue;
+    if ((xLeft < X) || (xLeft >= (X + W)))  continue;
+    if ((yTop < Y) || (yTop >= (Y + H)))  continue;
+
+    // Try to obtain child proxy
+    Fl_Msaa_Proxy* proxy = scroll->msaa_scroll_child(n);
+    if (proxy)
+    {
+	pvarChild->vt = VT_DISPATCH;
+	proxy->QueryInterface(IID_IDispatch, (void**)&pvarChild->pdispVal);
+	return S_OK;
+    }
+
+    // Otherwise return child ID
+    pvarChild->vt   = VT_I4;
+    pvarChild->lVal = n;
+    return S_OK;
+  }
+
+  pvarChild->vt   = VT_I4;
+  pvarChild->lVal = 0;
+  return S_OK;
+}
+
+
+HRESULT STDMETHODCALLTYPE
+Fl_Msaa_Scroll_Proxy::accDoDefaultAction(
+    /* [optional][in] */ VARIANT varChild)
+{
+  Fl_Scroll* scroll = (Fl_Scroll*)mpObj;
+  if (!scroll)  return CO_E_OBJNOTCONNECTED;
+  long id = (varChild.vt == VT_I4 ? varChild.lVal : 0);
+  if (id < 0 || id > scroll->msaa_scroll_size())  return E_INVALIDARG;
+
+  return DISP_E_MEMBERNOTFOUND;
+}
+
+
+HRESULT STDMETHODCALLTYPE
+Fl_Msaa_Scroll_Proxy::put_accValue(
+    /* [optional][in] */ VARIANT varChild,
+    /* [in] */ BSTR szValue)
+{
+  Fl_Scroll* scroll = (Fl_Scroll*)mpObj;
+  if (!scroll)  return CO_E_OBJNOTCONNECTED;
+  long id = (varChild.vt == VT_I4 ? varChild.lVal : 0);
+  if (id < 0 || id > scroll->msaa_scroll_size())  return E_INVALIDARG;
+
+  return DISP_E_MEMBERNOTFOUND;
+}
+
+
+/*------------------------- Fl_Scroll MSAA support -----------------------*/
+
+Fl_Msaa_Proxy*
+Fl_Scroll::msaa_proxy()
+{
+  // Create specialized proxy for Fl_Scroll widget
+  if (!msaa_scroll_proxy_)
+  {
+    msaa_scroll_proxy_ = new Fl_Msaa_Scroll_Proxy(this);
+    if (msaa_scroll_proxy_)  msaa_scroll_proxy_->AddRef();
+  }
+  return msaa_scroll_proxy_;
+}
+
+
+void
+Fl_Scroll::msaa_cleanup()
+{
+  // Destroy custom proxy
+  if (msaa_scroll_proxy_)
+  {
+    msaa_scroll_proxy_->Detach();
+    msaa_scroll_proxy_->Release();
+  }
+
+  // Destroy standard proxy
+  Fl_Group::msaa_cleanup();
+}
+
+
+bool
+Fl_Scroll::msaa_parent(IDispatch** dispatch)
+{
+  // Fl_Scroll widget's proxy has a Fl_Msaa_Scroll_Proxy parent
+  Fl_Msaa_Proxy* proxy = msaa_proxy();
+  if (!proxy)  return false;
+  proxy->QueryInterface(IID_IDispatch, (void**)dispatch);
+  return true;
+}
+
+
+bool
+Fl_Scroll::msaa_location(long id, long* X, long* Y, long* W, long* H)
+{
+  if (id != 0)  return Fl_Group::msaa_location(id, X, Y, W, H);
+  if (!msaa_visible())  return false;
+  msaa_scroll_bbox(X, Y, W, H);
+  return true;
+}
+
+
+long
+Fl_Scroll::msaa_role(long id)
+{
+  if (id != 0)  return Fl_Group::msaa_role(id);
+  return ROLE_SYSTEM_PANE;
+}
+
+
+bool
+Fl_Scroll::msaa_scroll_parent(IDispatch** dispatch)
+{
+  return Fl_Group::msaa_parent(dispatch);
+}
+
+
+Fl_Msaa_Proxy*
+Fl_Scroll::msaa_scroll_child(long id)
+{
+  switch (id)
+  {
+    case 0:		  return msaa_proxy();
+    case CID_INSIDE:	  return msaa_child(0);
+    case CID_VERTICAL:	  return scrollbar.msaa_proxy();
+    case CID_HORIZONTAL:  return hscrollbar.msaa_proxy();
+    default:		  return NULL;
+  }
+}
+
+
+void
+Fl_Scroll::msaa_scroll_bbox(long* X, long* Y, long* W, long* H)
+{
+  Fl_Window* win = window();
+  int oX, oY, oW, oH;
+  bbox(oX, oY, oW, oH);
+  *X = oX + win->x();
+  *Y = oY + win->y();
+  *W = oW;
+  *H = oH;
+}
+
+
+long
+Fl_Scroll::msaa_scroll_role(long id)
+{
+  switch (id)
+  {
+    case 0:		  return ROLE_SYSTEM_GROUPING;
+    case CID_GRIP:	  return ROLE_SYSTEM_GRIP;
+    default:		  return false;
+  }
+}
+
+
+long
+Fl_Scroll::msaa_scroll_state(long id)
+{
+  switch (id)
+  {
+    case 0:
+      return Fl_Group::msaa_state(0) & ~STATE_SYSTEM_FOCUSED;
+    case CID_GRIP:
+      return (scrollbar.visible() && hscrollbar.visible()) ?
+        0 : STATE_SYSTEM_INVISIBLE;
+    default:
+      return Fl_Group::msaa_state(id);
+  }
+}
+
+
+bool
+Fl_Scroll::msaa_scroll_location(long id, long* X, long* Y, long* W, long* H)
+{
+  if (!msaa_visible())  return false;
+  switch (id)
+  {
+    case 0:
+      return Fl_Widget::msaa_location(0, X, Y, W, H);
+    case CID_INSIDE:
+      msaa_scroll_bbox(X, Y, W, H);
+      return true;
+    case CID_VERTICAL:
+      return Fl_Group::msaa_location(find(&scrollbar) + 1, X, Y, W, H);
+    case CID_HORIZONTAL:
+      return Fl_Group::msaa_location(find(&hscrollbar) + 1, X, Y, W, H);
+    case CID_GRIP:
+      if (scrollbar.visible() && hscrollbar.visible())
+      {
+	long dummy;
+	Fl_Group::msaa_location(find(&scrollbar) + 1, X, &dummy, W, &dummy);
+	Fl_Group::msaa_location(find(&hscrollbar) + 1, &dummy, Y, &dummy, H);
+        return true;
+      }
+      return false;
+    default:
+      return false;
+  }
+}
+#endif // FL_HAVE_MSAA
+
 //
 // End of "$Id$".
 //
